searchNodes=[{"doc":"Provides functions for signing a map of &quot;claims&quot; into a JWT using a signing key.","ref":"NoWayJose.html","title":"NoWayJose","type":"module"},{"doc":"Generates a signed JWT from the given claims and key. Example # Get the private signing key {:ok, key} = File.read(&quot;private.der&quot;) # Build your claims claims = %{ &quot;exp&quot; =&gt; 1571065163, &quot;iat&quot; =&gt; 1571061563, &quot;iss&quot; =&gt; &quot;example.com&quot;, &quot;jti&quot; =&gt; &quot;a3a31258-2450-490b-86ed-2b8e67f91e20&quot;, &quot;nbf&quot; =&gt; 1571061563, &quot;scopes&quot; =&gt; [ &quot;posts.r+w&quot;, &quot;comments.r+w&quot; ], &quot;sub&quot; =&gt; &quot;4d3796ca-19e0-40e6-97fe-060c0b7e3ce3&quot; } # Sign the claims into a JWT {:ok, token} = NoWayJose.sign(claims, key)","ref":"NoWayJose.html#sign/2","title":"NoWayJose.sign/2","type":"function"},{"doc":"Generates a signed JWT from the given claims and key. Returns a JWT on success and raises an error on error.","ref":"NoWayJose.html#sign!/2","title":"NoWayJose.sign!/2","type":"function"},{"doc":"A map containing the claims to be encoded. Map keys must be strings.","ref":"NoWayJose.html#t:claims/0","title":"NoWayJose.claims/0","type":"type"},{"doc":"DER encoded RSA private key. Generating a key ssh-keygen -m PEM -t rsa -b 4096 -f private.pem Make sure not to set a passphrase. Convert the PEM to DER openssl rsa -in private.pem -outform DER -out private.der Optionally, you can extract the DER data from a PEM encoded private key in code using the following: {:ok, key} = File.read(&quot;private.pem&quot;) [{:RSAPrivateKey, der, _}] = :public_key.pem_decode(key)","ref":"NoWayJose.html#t:key/0","title":"NoWayJose.key/0","type":"type"},{"doc":"JSON Web Token","ref":"NoWayJose.html#t:token/0","title":"NoWayJose.token/0","type":"type"},{"doc":"NoWayJose Rust NIF for JWT signing","ref":"readme.html","title":"NoWayJose","type":"extras"},{"doc":"In its current state, this library only supports signing JWTs using the RS512 algo with a DER encoded RSA private key.","ref":"readme.html#features","title":"NoWayJose - Features","type":"extras"},{"doc":"def deps do [ {:no_way_jose, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"NoWayJose - Installation","type":"extras"},{"doc":"In order to sign a JWT an RSA private key must be provided. The key must be DER encoded. Generate an RSA public/private key pair ssh-keygen -m PEM -t rsa -b 4096 -f private.pem # Don&#39;t add passphrase Convert the PEM to DER openssl rsa -in private.pem -outform DER -out private.der Optionally, you can extract the DER data from a PEM encoded private key in code using the following: {:ok, key} = File.read(&quot;private.pem&quot;) [{:RSAPrivateKey, der, _}] = :public_key.pem_decode(key)","ref":"readme.html#generating-a-key","title":"NoWayJose - Generating a key","type":"extras"},{"doc":"# Get the private signing key {:ok, key} = File.read(&quot;private.der&quot;) # Build your claims claims = %{ &quot;exp&quot; =&gt; 1571065163, &quot;iat&quot; =&gt; 1571061563, &quot;iss&quot; =&gt; &quot;example.com&quot;, &quot;jti&quot; =&gt; &quot;a3a31258-2450-490b-86ed-2b8e67f91e20&quot;, &quot;nbf&quot; =&gt; 1571061563, &quot;scopes&quot; =&gt; [ &quot;posts.r+w&quot;, &quot;comments.r+w&quot; ], &quot;sub&quot; =&gt; &quot;4d3796ca-19e0-40e6-97fe-060c0b7e3ce3&quot; } # Sign the claims into a JWT {:ok, token} = NoWayJose.sign(claims, key)","ref":"readme.html#basic-usage","title":"NoWayJose - Basic usage","type":"extras"},{"doc":"Documentation can be be found at https://hexdocs.pm/no_way_jose.","ref":"readme.html#documentation","title":"NoWayJose - Documentation","type":"extras"},{"doc":"Please check the Roadmap if you&#39;re curious about the future of this project.","ref":"readme.html#roadmap","title":"NoWayJose - Roadmap","type":"extras"},{"doc":"A rhyming play on words to indicate that this library does not depend on JOSE.","ref":"readme.html#etymology","title":"NoWayJose - Etymology","type":"extras"},{"doc":"Apache 2.0","ref":"readme.html#license","title":"NoWayJose - License","type":"extras"}]